Index: drivers/video/aty/atyfb_base.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/aty/atyfb_base.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/aty/atyfb_base.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/aty/atyfb_base.c	4 Aug 2004 01:29:59 -0000	1.2
@@ -2157,339 +2437,547 @@
 
     /* Do not attach when we have a serial console. */
     if (!con_is_present())
-	return -ENXIO;
+        return -ENXIO;
 #else
     u16 tmp;
     int aux_app;
     unsigned long raddr;
 #endif
+#if defined(CONFIG_FB_ATY_GENERIC_LCD)
+    u16 lcd_ofs;
+    u32 driv_inf_tab,sig,rom_addr;
+#endif
 
     while ((pdev = pci_find_device(PCI_VENDOR_ID_ATI, PCI_ANY_ID, pdev))) {
-	if ((pdev->class >> 16) == PCI_BASE_CLASS_DISPLAY) {
-	    struct resource *rp;
+        if ((pdev->class >> 16) == PCI_BASE_CLASS_DISPLAY) {
+            struct resource *rp;
 #ifndef __sparc__
-	    struct resource *rrp;
+            struct resource *rrp;
 #endif
 
-	    for (i = sizeof(aty_chips)/sizeof(*aty_chips)-1; i >= 0; i--)
-		if (pdev->device == aty_chips[i].pci_id)
-		    break;
-	    if (i < 0)
-		continue;
-
-	    info = kmalloc(sizeof(struct fb_info_aty), GFP_ATOMIC);
-	    if (!info) {
-		printk("atyfb_init: can't alloc fb_info_aty\n");
-		return -ENXIO;
-	    }
-	    memset(info, 0, sizeof(struct fb_info_aty));
-
-	    rp = &pdev->resource[0];
-	    if (rp->flags & IORESOURCE_IO)
-		    rp = &pdev->resource[1];
-	    addr = rp->start;
-	    if (!addr)
-		continue;
-
-	    res_start = rp->start;
-	    res_size = rp->end-rp->start+1;
-	    if (!request_mem_region(res_start, res_size, "atyfb"))
-		continue;
+            for (i = sizeof(aty_chips)/sizeof(*aty_chips)-1; i >= 0; i--)
+                if (pdev->device == aty_chips[i].pci_id)
+                    break;
+            if (i < 0)
+                continue;
+
+            info = kmalloc(sizeof(struct fb_info_aty), GFP_ATOMIC);
+            if (!info) {
+                printk("atyfb_init: can't alloc fb_info_aty\n");
+                return -ENXIO;
+            }
+            memset(info, 0, sizeof(struct fb_info_aty));
+
+            rp = &pdev->resource[0];
+            if (rp->flags & IORESOURCE_IO)
+                    rp = &pdev->resource[1];
+            addr = rp->start;
+            if (!addr)
+                continue;
+
+            res_start = rp->start;
+            res_size = rp->end-rp->start+1;
+            if (!request_mem_region(res_start, res_size, "atyfb"))
+                continue;
 
 #ifdef __sparc__
-	    /*
-	     * Map memory-mapped registers.
-	     */
-	    info->ati_regbase = addr + 0x7ffc00UL;
-	    info->ati_regbase_phys = addr + 0x7ffc00UL;
-
-	    /*
-	     * Map in big-endian aperture.
-	     */
-	    info->frame_buffer = (unsigned long) addr + 0x800000UL;
-	    info->frame_buffer_phys = addr + 0x800000UL;
-
-	    /*
-	     * Figure mmap addresses from PCI config space.
-	     * Split Framebuffer in big- and little-endian halfs.
-	     */
-	    for (i = 0; i < 6 && pdev->resource[i].start; i++)
-		/* nothing */;
-	    j = i + 4;
-
-	    info->mmap_map = kmalloc(j * sizeof(*info->mmap_map), GFP_ATOMIC);
-	    if (!info->mmap_map) {
-		printk("atyfb_init: can't alloc mmap_map\n");
-		kfree(info);
-		release_mem_region(res_start, res_size);
-		return -ENXIO;
-	    }
-	    memset(info->mmap_map, 0, j * sizeof(*info->mmap_map));
-
-	    for (i = 0, j = 2; i < 6 && pdev->resource[i].start; i++) {
-		struct resource *rp = &pdev->resource[i];
-		int io, breg = PCI_BASE_ADDRESS_0 + (i << 2);
-		unsigned long base;
-		u32 size, pbase;
-
-		base = rp->start;
-
-		io = (rp->flags & IORESOURCE_IO);
-
-		size = rp->end - base + 1;
-
-		pci_read_config_dword(pdev, breg, &pbase);
-
-		if (io)
-			size &= ~1;
-
-		/*
-		 * Map the framebuffer a second time, this time without
-		 * the braindead _PAGE_IE setting. This is used by the
-		 * fixed Xserver, but we need to maintain the old mapping
-		 * to stay compatible with older ones...
-		 */
-		if (base == addr) {
-		    info->mmap_map[j].voff = (pbase + 0x10000000) & PAGE_MASK;
-		    info->mmap_map[j].poff = base & PAGE_MASK;
-		    info->mmap_map[j].size = (size + ~PAGE_MASK) & PAGE_MASK;
-		    info->mmap_map[j].prot_mask = _PAGE_CACHE;
-		    info->mmap_map[j].prot_flag = _PAGE_E;
-		    j++;
-		}
-
-		/*
-		 * Here comes the old framebuffer mapping with _PAGE_IE
-		 * set for the big endian half of the framebuffer...
-		 */
-		if (base == addr) {
-		    info->mmap_map[j].voff = (pbase + 0x800000) & PAGE_MASK;
-		    info->mmap_map[j].poff = (base+0x800000) & PAGE_MASK;
-		    info->mmap_map[j].size = 0x800000;
-		    info->mmap_map[j].prot_mask = _PAGE_CACHE;
-		    info->mmap_map[j].prot_flag = _PAGE_E|_PAGE_IE;
-		    size -= 0x800000;
-		    j++;
-		}
-
-		info->mmap_map[j].voff = pbase & PAGE_MASK;
-		info->mmap_map[j].poff = base & PAGE_MASK;
-		info->mmap_map[j].size = (size + ~PAGE_MASK) & PAGE_MASK;
-		info->mmap_map[j].prot_mask = _PAGE_CACHE;
-		info->mmap_map[j].prot_flag = _PAGE_E;
-		j++;
-	    }
-
-	    if (pdev->device != XL_CHIP_ID) {
-		    /*
-		     * Fix PROMs idea of MEM_CNTL settings...
-		     */
-		    mem = aty_ld_le32(MEM_CNTL, info);
-		    chip_id = aty_ld_le32(CONFIG_CHIP_ID, info);
-		    if (((chip_id & CFG_CHIP_TYPE) == VT_CHIP_ID) &&
-			!((chip_id >> 24) & 1)) {
-			switch (mem & 0x0f) {
-			    case 3:
-				mem = (mem & ~(0x0f)) | 2;
-				break;
-			    case 7:
-				mem = (mem & ~(0x0f)) | 3;
-				break;
-			    case 9:
-				mem = (mem & ~(0x0f)) | 4;
-				break;
-			    case 11:
-				mem = (mem & ~(0x0f)) | 5;
-				break;
-			    default:
-				break;
-			}
-			if ((aty_ld_le32(CONFIG_STAT0, info) & 7) >= SDRAM)
-				mem &= ~(0x00700000);
-		    }
-		    mem &= ~(0xcf80e000);	/* Turn off all undocumented bits. */
-		    aty_st_le32(MEM_CNTL, mem, info);
-	    }
+            /*
+             * Map memory-mapped registers.
+             */
+            info->ati_regbase = addr + 0x7ffc00UL;
+            info->ati_regbase_phys = addr + 0x7ffc00UL;
+
+            /*
+             * Map in big-endian aperture.
+             */
+            info->frame_buffer = (unsigned long) addr + 0x800000UL;
+            info->frame_buffer_phys = addr + 0x800000UL;
+
+            aty_init_register_array(info);
+
+            /*
+             * Figure mmap addresses from PCI config space.
+             * Split Framebuffer in big- and little-endian halfs.
+             */
+            for (i = 0; i < 6 && pdev->resource[i].start; i++)
+                /* nothing */;
+            j = i + 4;
+
+            info->mmap_map = kmalloc(j * sizeof(*info->mmap_map), GFP_ATOMIC);
+            if (!info->mmap_map) {
+                printk("atyfb_init: can't alloc mmap_map\n");
+                kfree(info);
+                release_mem_region(res_start, res_size);
+                return -ENXIO;
+            }
+            memset(info->mmap_map, 0, j * sizeof(*info->mmap_map));
+
+            for (i = 0, j = 2; i < 6 && pdev->resource[i].start; i++) {
+                struct resource *rp = &pdev->resource[i];
+                int io, breg = PCI_BASE_ADDRESS_0 + (i << 2);
+                unsigned long base;
+                u32 size, pbase;
+
+                base = rp->start;
+
+                io = (rp->flags & IORESOURCE_IO);
+
+                size = rp->end - base + 1;
+
+                pci_read_config_dword(pdev, breg, &pbase);
+
+                if (io)
+                        size &= ~1;
+
+                /*
+                 * Map the framebuffer a second time, this time without
+                 * the braindead _PAGE_IE setting. This is used by the
+                 * fixed Xserver, but we need to maintain the old mapping
+                 * to stay compatible with older ones...
+                 */
+                if (base == addr) {
+                    info->mmap_map[j].voff = (pbase + 0x10000000) & PAGE_MASK;
+                    info->mmap_map[j].poff = base & PAGE_MASK;
+                    info->mmap_map[j].size = (size + ~PAGE_MASK) & PAGE_MASK;
+                    info->mmap_map[j].prot_mask = _PAGE_CACHE;
+                    info->mmap_map[j].prot_flag = _PAGE_E;
+                    j++;
+                }
+
+                /*
+                 * Here comes the old framebuffer mapping with _PAGE_IE
+                 * set for the big endian half of the framebuffer...
+                 */
+                if (base == addr) {
+                    info->mmap_map[j].voff = (pbase + 0x800000) & PAGE_MASK;
+                    info->mmap_map[j].poff = (base+0x800000) & PAGE_MASK;
+                    info->mmap_map[j].size = 0x800000;
+                    info->mmap_map[j].prot_mask = _PAGE_CACHE;
+                    info->mmap_map[j].prot_flag = _PAGE_E|_PAGE_IE;
+                    size -= 0x800000;
+                    j++;
+                }
+
+                info->mmap_map[j].voff = pbase & PAGE_MASK;
+                info->mmap_map[j].poff = base & PAGE_MASK;
+                info->mmap_map[j].size = (size + ~PAGE_MASK) & PAGE_MASK;
+                info->mmap_map[j].prot_mask = _PAGE_CACHE;
+                info->mmap_map[j].prot_flag = _PAGE_E;
+                j++;
+            }
+
+            if (pdev->device != XL_CHIP_ID) {
+                    /*
+                     * Fix PROMs idea of MEM_CNTL settings...
+                     */
+                    mem = aty_ld_le32(MEM_CNTL, info);
+                    chip_id = aty_ld_le32(CONFIG_CHIP_ID, info);
+                    if (((chip_id & CFG_CHIP_TYPE) == VT_CHIP_ID) &&
+                        !((chip_id >> 24) & 1)) {
+                        switch (mem & 0x0f) {
+                            case 3:
+                                mem = (mem & ~(0x0f)) | 2;
+                                break;
+                            case 7:
+                                mem = (mem & ~(0x0f)) | 3;
+                                break;
+                            case 9:
+                                mem = (mem & ~(0x0f)) | 4;
+                                break;
+                            case 11:
+                                mem = (mem & ~(0x0f)) | 5;
+                                break;
+                            default:
+                                break;
+                        }
+                        if ((aty_ld_le32(CONFIG_STAT0, info) & 7) >= SDRAM)
+                                mem &= ~(0x00700000);
+                    }
+                    mem &= ~(0xcf80e000);       /* Turn off all undocumented bits. */
+                    aty_st_le32(MEM_CNTL, mem, info);
+            }
+
+            /*
+             * If this is the console device, we will set default video
+             * settings to what the PROM left us with.
+             */
+            node = prom_getchild(prom_root_node);
+            node = prom_searchsiblings(node, "aliases");
+            if (node) {
+                len = prom_getproperty(node, "screen", prop, sizeof(prop));
+                if (len > 0) {
+                    prop[len] = '\0';
+                    node = prom_finddevice(prop);
+                } else {
+                    node = 0;
+                }
+            }
+
+            pcp = pdev->sysdata;
+            if (node == pcp->prom_node) {
+
+                struct fb_var_screeninfo *var = &default_var;
+                unsigned int N, P, Q, M, T, R;
+                u32 v_total, h_total;
+                struct crtc crtc;
+                u8 pll_regs[16];
+                u8 clock_cntl;
+
+                crtc.vxres = prom_getintdefault(node, "width", 1024);
+                crtc.vyres = prom_getintdefault(node, "height", 768);
+                crtc.bpp = prom_getintdefault(node, "depth", 8);
+                crtc.xoffset = crtc.yoffset = 0;
+                crtc.h_tot_disp = aty_ld_le32(CRTC_H_TOTAL_DISP, info);
+                crtc.h_sync_strt_wid = aty_ld_le32(CRTC_H_SYNC_STRT_WID, info);
+                crtc.v_tot_disp = aty_ld_le32(CRTC_V_TOTAL_DISP, info);
+                crtc.v_sync_strt_wid = aty_ld_le32(CRTC_V_SYNC_STRT_WID, info);
+                crtc.gen_cntl = aty_ld_le32(CRTC_GEN_CNTL, info);
+                aty_crtc_to_var(&crtc, var);
+
+                h_total = var->xres + var->right_margin +
+                          var->hsync_len + var->left_margin;
+                v_total = var->yres + var->lower_margin +
+                          var->vsync_len + var->upper_margin;
+
+                /*
+                 * Read the PLL to figure actual Refresh Rate.
+                 */
+                clock_cntl = aty_ld_8(CLOCK_CNTL, info);
+                /* printk("atyfb: CLOCK_CNTL: %02x\n", clock_cntl); */
+                for (i = 0; i < 16; i++)
+                        pll_regs[i] = aty_ld_pll(i, info);
+
+                /*
+                 * PLL Reference Divider M:
+                 */
+                M = pll_regs[2];
+
+                /*
+                 * PLL Feedback Divider N (Dependant on CLOCK_CNTL):
+                 */
+                N = pll_regs[7 + (clock_cntl & 3)];
+
+                /*
+                 * PLL Post Divider P (Dependant on CLOCK_CNTL):
+                 */
+                P = 1 << (pll_regs[6] >> ((clock_cntl & 3) << 1));
+
+                /*
+                 * PLL Divider Q:
+                 */
+                Q = N / P;
+
+                /*
+                 * Target Frequency:
+                 *
+                 *      T * M
+                 * Q = -------
+                 *      2 * R
+                 *
+                 * where R is XTALIN (= 14318 or 29498 kHz).
+                 */
+                if (pdev->device == XL_CHIP_ID)
+                        R = 29498;
+                else
+                        R = 14318;
 
-	    /*
-	     * If this is the console device, we will set default video
-	     * settings to what the PROM left us with.
-	     */
-	    node = prom_getchild(prom_root_node);
-	    node = prom_searchsiblings(node, "aliases");
-	    if (node) {
-		len = prom_getproperty(node, "screen", prop, sizeof(prop));
-		if (len > 0) {
-		    prop[len] = '\0';
-		    node = prom_finddevice(prop);
-		} else {
-		    node = 0;
-		}
-	    }
-
-	    pcp = pdev->sysdata;
-	    if (node == pcp->prom_node) {
+                T = 2 * Q * R / M;
 
-		struct fb_var_screeninfo *var = &default_var;
-		unsigned int N, P, Q, M, T, R;
-		u32 v_total, h_total;
-		struct crtc crtc;
-		u8 pll_regs[16];
-		u8 clock_cntl;
-
-		crtc.vxres = prom_getintdefault(node, "width", 1024);
-		crtc.vyres = prom_getintdefault(node, "height", 768);
-		crtc.bpp = prom_getintdefault(node, "depth", 8);
-		crtc.xoffset = crtc.yoffset = 0;
-		crtc.h_tot_disp = aty_ld_le32(CRTC_H_TOTAL_DISP, info);
-		crtc.h_sync_strt_wid = aty_ld_le32(CRTC_H_SYNC_STRT_WID, info);
-		crtc.v_tot_disp = aty_ld_le32(CRTC_V_TOTAL_DISP, info);
-		crtc.v_sync_strt_wid = aty_ld_le32(CRTC_V_SYNC_STRT_WID, info);
-		crtc.gen_cntl = aty_ld_le32(CRTC_GEN_CNTL, info);
-		aty_crtc_to_var(&crtc, var);
-
-		h_total = var->xres + var->right_margin +
-			  var->hsync_len + var->left_margin;
-		v_total = var->yres + var->lower_margin +
-			  var->vsync_len + var->upper_margin;
-
-		/*
-		 * Read the PLL to figure actual Refresh Rate.
-		 */
-    		clock_cntl = aty_ld_8(CLOCK_CNTL, info);
-		/* printk("atyfb: CLOCK_CNTL: %02x\n", clock_cntl); */
-		for (i = 0; i < 16; i++)
-			pll_regs[i] = aty_ld_pll(i, info);
-
-		/*
-		 * PLL Reference Divider M:
-		 */
-		M = pll_regs[2];
-
-		/*
-		 * PLL Feedback Divider N (Dependant on CLOCK_CNTL):
-		 */
-		N = pll_regs[7 + (clock_cntl & 3)];
-
-		/*
-		 * PLL Post Divider P (Dependant on CLOCK_CNTL):
-		 */
-		P = 1 << (pll_regs[6] >> ((clock_cntl & 3) << 1));
-
-		/*
-		 * PLL Divider Q:
-		 */
-		Q = N / P;
-
-		/*
-		 * Target Frequency:
-		 *
-		 *      T * M
-		 * Q = -------
-		 *      2 * R
-		 *
-		 * where R is XTALIN (= 14318 or 29498 kHz).
-		 */
-		if (pdev->device == XL_CHIP_ID)
-			R = 29498;
-		else
-			R = 14318;
+                default_var.pixclock = 1000000000 / T;
+            }
 
-		T = 2 * Q * R / M;
-
-		default_var.pixclock = 1000000000 / T;
-	    }
 #else /* __sparc__ */
 
-	    aux_app = 0;
-	    raddr = addr + 0x7ff000UL;
-	    rrp = &pdev->resource[2];
-	    if ((rrp->flags & IORESOURCE_MEM)
-		&& request_mem_region(rrp->start, rrp->end - rrp->start + 1,
-				      "atyfb")) {
-		    aux_app = 1;
-		    raddr = rrp->start;
-		    printk(KERN_INFO "atyfb: using auxiliary register aperture\n");
-	    }
-
-	    info->ati_regbase_phys = raddr;
-	    info->ati_regbase = (unsigned long) ioremap(raddr, 0x1000);
-
-	    if(!info->ati_regbase) {
-		    kfree(info);
-		    release_mem_region(res_start, res_size);
-		    return -ENOMEM;
-	    }
-
-	    info->ati_regbase_phys += aux_app? 0x400: 0xc00;
-	    info->ati_regbase += aux_app? 0x400: 0xc00;
-
-	    /*
-	     * Enable memory-space accesses using config-space
-	     * command register.
-	     */
-	    pci_read_config_word(pdev, PCI_COMMAND, &tmp);
-	    if (!(tmp & PCI_COMMAND_MEMORY)) {
-		tmp |= PCI_COMMAND_MEMORY;
-		pci_write_config_word(pdev, PCI_COMMAND, tmp);
-	    }
+            aux_app = 0;
+            raddr = addr + 0x7ff000UL;
+            rrp = &pdev->resource[2];
+            if ((rrp->flags & IORESOURCE_MEM)
+                && request_mem_region(rrp->start, rrp->end - rrp->start + 1,
+                                      "atyfb")) {
+                    aux_app = 1;
+                    raddr = rrp->start;
+                    printk(KERN_INFO "atyfb: using auxiliary register aperture\n");
+            }
+
+            info->ati_regbase_phys = raddr;
+            info->ati_regbase = (unsigned long) ioremap(raddr, 0x1000);
+
+            if(!info->ati_regbase) {
+                    kfree(info);
+                    release_mem_region(res_start, res_size);
+                    return -ENOMEM;
+            }
+
+            info->ati_regbase_phys += aux_app? 0x400: 0xc00;
+            info->ati_regbase += aux_app? 0x400: 0xc00;
+
+            /*
+             * Enable memory-space accesses using config-space
+             * command register.
+             */
+            pci_read_config_word(pdev, PCI_COMMAND, &tmp);
+            if (!(tmp & PCI_COMMAND_MEMORY)) {
+                tmp |= PCI_COMMAND_MEMORY;
+                pci_write_config_word(pdev, PCI_COMMAND, tmp);
+            }
 
 #ifdef __BIG_ENDIAN
-	    /* Use the big-endian aperture */
-	    addr += 0x800000;
+            /* Use the big-endian aperture */
+            addr += 0x800000;
 #endif
 
-	    /* Map in frame buffer */
-	    info->frame_buffer_phys = addr;
-	    info->frame_buffer = (unsigned long)ioremap(addr, 0x800000);
-
-	    if(!info->frame_buffer) {
-		    kfree(info);
-		    release_mem_region(res_start, res_size);
-		    return -ENXIO;
-	    }
+            /* Map in frame buffer */
+            info->frame_buffer_phys = addr;
+            info->frame_buffer = (unsigned long)ioremap(addr, 0x800000);
+
+            aty_init_register_array(info);
+
+#ifdef CONFIG_FB_ATY_GENERIC_LCD
+            /* To support an LCD panel, we should know it's dimensions and
+               it's desired pixel clock.
+               There are two ways to do it:
+                 - Check the startup video mode and calculate the panel
+                   size from it. This is unreliable.
+                 - Read it from the driver information table in the video BIOS.
+                 
+               So, we try to find a BIOS and get access to it.
+            */
+            rom_addr = 0xc0000 + ((aty_ld_le32(SCRATCH_REG1,info) & 0x7f) << 11);
+            info->bios_base_phys = rom_addr;
+            info->bios_base = (unsigned long)ioremap(rom_addr,0x10000);
+            
+            /* The BIOS starts with 0xaa55. */
+            if (*((u16 *)info->bios_base) == 0xaa55) {
+                printk(KERN_INFO "atyfb: Mach64 BIOS is located at %x, mapped at %x.\n",
+                 (u32)info->bios_base_phys,(u32)info->bios_base);
+            
+                /* Address of driver information table is at offset 0x78. */
+                driv_inf_tab=info->bios_base + *((u16 *)(info->bios_base+0x78));
+                
+                /* Check for the driver information table signature. */
+                sig = (*(u32 *)driv_inf_tab);
+                if ((sig == 0x54504c24) || /* Rage LT pro */
+                    (sig == 0x544d5224) || /* Rage mobility */
+                    (sig == 0x54435824) || /* Rage XC */
+                    (sig == 0x544c5824)) { /* Rage XL */
+                    printk(KERN_INFO "atyfb: BIOS contains driver information table.\n");
+                    lcd_ofs = (*(u16 *)(driv_inf_tab + 10));
+                    info->lcd_table = 0;
+                    if (lcd_ofs != 0) {
+                        info->lcd_table = info->bios_base + lcd_ofs;
+                    };
+                };
+            };
+            if (info->lcd_table != 0) {
+                char model[24];
+                char strbuf[16];
+                char refresh_rates_buf[100];
+                int id,tech,f,i,m,default_refresh_rate;
+                char *txtcolour;
+                char *txtmonitor;
+                char *txtdual;
+                char *txtformat;
+                u16 width,height,panel_type,refresh_rates;
+                u16 *lcdmodeptr;
+                u32 format;
+                u8 lcd_refresh_rates[16] = {50,56,60,67,70,72,75,76,85,90,100,120,140,150,160,200};
+                /* The most important information is the panel size at
+                   offset 25 and 27, but there's some other nice information
+                   which we print to the screen.
+                 */
+                id = *(u8 *)info->lcd_table;
+                strncpy(model,(char *)info->lcd_table+1,24);
+                model[23]=0;
+                
+                width = info->lcd_width = *(u16 *)(info->lcd_table+25);
+                height = info->lcd_height = *(u16 *)(info->lcd_table+27);
+                panel_type = *(u16 *)(info->lcd_table+29);
+                if (panel_type & 1)
+                    txtcolour = "colour";
+                else
+                    txtcolour = "monochrome";
+                if (panel_type & 2)
+                    txtdual = "dual (split) ";
+                else
+                    txtdual = "";
+                tech = (panel_type>>2) & 63;
+                switch (tech) {
+                    case 0:
+                        txtmonitor = "passive matrix";
+                        break;
+                    case 1:
+                        txtmonitor = "active matrix";
+                        break;
+                    case 2:
+                        txtmonitor = "active addressed STN";
+                        break;
+                    case 3:
+                        txtmonitor = "EL";
+                        break;
+                    case 4:
+                        txtmonitor = "plasma";
+                        break;
+                    default:
+                        txtmonitor = "unknown";
+                };
+                format = *(u32 *)(info->lcd_table+57);
+                if (tech == 0 || tech == 2) {
+                    switch (format & 7) {
+                        case 0:
+                            txtformat = "12 bit interface";
+                            break;
+                        case 1:
+                            txtformat = "16 bit interface";
+                            break;
+                        case 2:
+                            txtformat = "24 bit interface";
+                            break;
+                        default:
+                            txtformat = "unkown format";
+                    };
+                } else {
+                    switch (format & 7) {
+                        case 0:
+                            txtformat = "8 colours";
+                            break;
+                        case 1:
+                            txtformat = "512 colours";
+                            break;
+                        case 2:
+                            txtformat = "4096 colours";
+                            break;
+                        case 4:
+                            txtformat = "262144 colours (LT mode)";
+                            break;
+                        case 5:
+                            txtformat = "16777216 colours";
+                            break;
+                        case 6:
+                            txtformat = "262144 colours (FDPI-2 mode)";
+                            break;
+                        default:
+                            txtformat = "unkown format";
+                    };
+                };
+                printk(KERN_INFO "atyfb: %s%s %s monitor detected: %s\n        id=%d, %dx%d pixels, %s\n",
+                 txtdual,txtcolour,txtmonitor,model,id,width,height,txtformat);
+                refresh_rates_buf[0] = 0;
+                refresh_rates = *(u16 *)(info->lcd_table+62);
+                m = 1;
+                f = 0;
+                for (i=0;i<16;i++) {
+                    if (refresh_rates & m) {
+                        if (f == 0) {
+                            sprintf(strbuf,"%d",lcd_refresh_rates[i]);
+                            f++;
+                        } else
+                            sprintf(strbuf,",%d",lcd_refresh_rates[i]);
+                        strcat(refresh_rates_buf,strbuf);
+                    };
+                    m = m << 1;
+                };
+                default_refresh_rate = (*(u8 *)(info->lcd_table+61) & 0xf0) >> 4;
+                printk(KERN_INFO "        supports %s Hz refresh rates, default %d Hz\n",
+                 refresh_rates_buf,lcd_refresh_rates[default_refresh_rate]);
+                /* We now need to determine the crtc parameters for the
+                   lcd monitor. This is tricky, because they are not stored
+                   individually in the BIOS. Instead, the BIOS contains a
+                   table of display modes that work for this monitor.
+                   
+                   The idea is that we search for a mode of the same dimensions
+                   as the dimensions of the lcd monitor. Say our lcd monitor
+                   is 800x600 pixels, we search for a 800x600 monitor.
+                   The CRTC parameters we find here are the ones that we need
+                   to use to simulate other resolutions on the lcd screen.
+                 */
+                lcdmodeptr = (u16 *)(info->lcd_table + 64);
+                while (*lcdmodeptr != 0) {
+                    u32 modeptr;
+                    u16 mwidth,mheight;
+                    modeptr = info->bios_base + *lcdmodeptr;
+                    
+                    mwidth = *((u16 *)(modeptr+0));
+                    mheight = *((u16 *)(modeptr+2));
+                    
+                    if (mwidth == width && mheight == height) {
+                        info->lcd_pixclock = 100000000 / *((u16 *)(modeptr+9));
+                        info->lcd_htotal = *((u16 *)(modeptr+17)) & 511;
+                        info->lcd_hdisp = *((u16 *)(modeptr+19)) & 511;
+                        info->lcd_hsync_start = *((u16 *)(modeptr+21)) & 511;
+                        info->lcd_hsync_delay = (*((u16 *)(modeptr+21)) >> 9) & 7;
+                        info->lcd_hsync_width = *((u8 *)(modeptr+23)) & 63;
+                        info->lcd_vtotal = *((u16 *)(modeptr+24)) & 2047;
+                        info->lcd_vdisp = *((u16 *)(modeptr+26)) & 2047;
+                        info->lcd_vsync_start = *((u16 *)(modeptr+28)) & 2047;
+                        info->lcd_vsync_width = (*((u16 *)(modeptr+28)) >> 11) & 31;
+                        info->lcd_right = info->lcd_hsync_start - info->lcd_hdisp;
+                        info->lcd_lower = info->lcd_vsync_start - info->lcd_vdisp;
+                        info->lcd_hblank_width = info->lcd_htotal - info->lcd_hdisp;
+                        info->lcd_vblank_width = info->lcd_vtotal - info->lcd_vdisp;
+                        break;
+                    };
+                    
+                    lcdmodeptr++;
+                };
+                if (*lcdmodeptr == 0) {
+                    printk(KERN_WARNING "atyfb: LCD monitor CRTC parameters not found!!!\n");
+                    /* To do: Switch to CRT if possible. */
+                } else {
+                    printk(KERN_INFO "        LCD CRTC parameters: %d %d %d %d %d %d %d %d %d %d\n",
+                     info->lcd_pixclock,info->lcd_htotal,info->lcd_hdisp,info->lcd_hsync_start,
+                     info->lcd_hsync_delay,info->lcd_hsync_width,info->lcd_vtotal,info->lcd_vdisp,
+                     info->lcd_vsync_start,info->lcd_vsync_width);
+                };
+            };
+#endif
+
+            if(!info->frame_buffer) {
+                    kfree(info);
+                    release_mem_region(res_start, res_size);
+                    return -ENXIO;
+            }
 
 #endif /* __sparc__ */
 
-	    if (!aty_init(info, "PCI")) {
-		if (info->mmap_map)
-		    kfree(info->mmap_map);
-		kfree(info);
-		release_mem_region(res_start, res_size);
-		return -ENXIO;
-	    }
+            if (!aty_init(info, "PCI")) {
+                if (info->mmap_map)
+                    kfree(info->mmap_map);
+                kfree(info);
+                release_mem_region(res_start, res_size);
+                return -ENXIO;
+            }
 
 #ifdef __sparc__
-	    if (!prom_palette)
-		prom_palette = atyfb_palette;
+            if (!prom_palette)
+                prom_palette = atyfb_palette;
 
-	    /*
-	     * Add /dev/fb mmap values.
-	     */
-	    info->mmap_map[0].voff = 0x8000000000000000UL;
-	    info->mmap_map[0].poff = info->frame_buffer & PAGE_MASK;
-	    info->mmap_map[0].size = info->total_vram;
-	    info->mmap_map[0].prot_mask = _PAGE_CACHE;
-	    info->mmap_map[0].prot_flag = _PAGE_E;
-	    info->mmap_map[1].voff = info->mmap_map[0].voff + info->total_vram;
-	    info->mmap_map[1].poff = info->ati_regbase & PAGE_MASK;
-	    info->mmap_map[1].size = PAGE_SIZE;
-	    info->mmap_map[1].prot_mask = _PAGE_CACHE;
-	    info->mmap_map[1].prot_flag = _PAGE_E;
+            /*
+             * Add /dev/fb mmap values.
+             */
+            info->mmap_map[0].voff = 0x8000000000000000UL;
+            info->mmap_map[0].poff = info->frame_buffer & PAGE_MASK;
+            info->mmap_map[0].size = info->total_vram;
+            info->mmap_map[0].prot_mask = _PAGE_CACHE;
+            info->mmap_map[0].prot_flag = _PAGE_E;
+            info->mmap_map[1].voff = info->mmap_map[0].voff + info->total_vram;
+            info->mmap_map[1].poff = info->ati_regbase & PAGE_MASK;
+            info->mmap_map[1].size = PAGE_SIZE;
+            info->mmap_map[1].prot_mask = _PAGE_CACHE;
+            info->mmap_map[1].prot_flag = _PAGE_E;
 #endif /* __sparc__ */
 
 #ifdef CONFIG_PMAC_PBOOK
-	    if (first_display == NULL)
-		    pmu_register_sleep_notifier(&aty_sleep_notifier);
-	    info->next = first_display;
-	    first_display = info;
+            if (first_display == NULL)
+                    pmu_register_sleep_notifier(&aty_sleep_notifier);
+            info->next = first_display;
+            first_display = info;
 #endif
 
 #ifdef CONFIG_FB_COMPAT_XPMAC
-	    if (!console_fb_info)
-		console_fb_info = &info->fb_info;
+            if (!console_fb_info)
+                console_fb_info = &info->fb_info;
 #endif /* CONFIG_FB_COMPAT_XPMAC */
-	}
+        }
     }
 
 #elif defined(CONFIG_ATARI)
